/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VIsElementRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VIsElement extends TableImpl<VIsElementRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_is_element</code>
     */
    public static final VIsElement V_IS_ELEMENT = new VIsElement();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VIsElementRecord> getRecordType() {
        return VIsElementRecord.class;
    }

    /**
     * The column <code>common_dd.v_is_element.key_element</code>.
     */
    public final TableField<VIsElementRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_is_element.dn</code>.
     */
    public final TableField<VIsElementRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_is_element.element_type</code>.
     */
    public final TableField<VIsElementRecord, String> ELEMENT_TYPE = createField(DSL.name("element_type"), SQLDataType.CLOB, this, "");

    private VIsElement(Name alias, Table<VIsElementRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VIsElement(Name alias, Table<VIsElementRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
         create view "v_is_element" as  SELECT v_is_studygroup.key_element,
            v_is_studygroup.dn,
            'studygroup'::text AS element_type
           FROM common_dd.v_is_studygroup
        UNION ALL
         SELECT v_is_study.key_element,
            v_is_study.dn,
            'study'::text AS element_type
           FROM common_dd.v_is_study
        UNION ALL
         SELECT v_is_department.key_element,
            v_is_department.dn,
            'department'::text AS element_type
           FROM common_dd.v_is_department
        UNION ALL
         SELECT v_is_subdepartment.key_element,
            v_is_subdepartment.dn,
            'subdepartment'::text AS element_type
           FROM common_dd.v_is_subdepartment
        UNION ALL
         SELECT v_is_form.key_element,
            v_is_form.dn,
            'form'::text AS element_type
           FROM common_dd.v_is_form
        UNION ALL
         SELECT v_is_variable.key_element,
            v_is_variable.dn,
            'variable'::text AS element_type
           FROM common_dd.v_is_variable;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_is_element</code> table reference
     */
    public VIsElement(String alias) {
        this(DSL.name(alias), V_IS_ELEMENT);
    }

    /**
     * Create an aliased <code>common_dd.v_is_element</code> table reference
     */
    public VIsElement(Name alias) {
        this(alias, V_IS_ELEMENT);
    }

    /**
     * Create a <code>common_dd.v_is_element</code> table reference
     */
    public VIsElement() {
        this(DSL.name("v_is_element"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VIsElement as(String alias) {
        return new VIsElement(DSL.name(alias), this);
    }

    @Override
    public VIsElement as(Name alias) {
        return new VIsElement(alias, this);
    }

    @Override
    public VIsElement as(Table<?> alias) {
        return new VIsElement(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsElement rename(String name) {
        return new VIsElement(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsElement rename(Name name) {
        return new VIsElement(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsElement rename(Table<?> name) {
        return new VIsElement(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsElement where(Condition condition) {
        return new VIsElement(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsElement where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsElement where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsElement where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsElement where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsElement where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsElement where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsElement where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsElement whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsElement whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
